{**** PCX_Dat.INC **** PCX-Dateien einbinden ****}

PROCEDURE Select_Plane(Plane_Nr:BYTE);
{Umschalten der Farbebenen}
CONST Sequencer_Index  : WORD = $03C4;
      Sequencer_Daten  : WORD = $03C5;
      Map_Mask         : BYTE = $02;

BEGIN
 Port[Sequencer_Index]:=Map_Mask;
 CASE Plane_Nr OF
   0:   Port[Sequencer_Daten]:=$01;
   1:   Port[Sequencer_Daten]:=$02;
   2:   Port[Sequencer_Daten]:=$04;
   3:   Port[Sequencer_Daten]:=$08;
   4:   Port[Sequencer_Daten]:=$0F;
 END;
END;

PROCEDURE PCX_Laden_VGA(Name : STRING);
TYPE Kopf = RECORD
             id    : BYTE;
             ver   : BYTE;
             komp  : BYTE;
             bits  : BYTE;
             x1,y1 : WORD;
             x2,y2 : WORD;
             ax,ay : WORD;
             pal   : ARRAY[1..48] OF BYTE;
             res1  : BYTE;
             ebene : BYTE;
             bz    : WORD;
             pal2  : WORD;
             res2  : ARRAY[1..58] OF BYTE;
            END;
      Bildspeicher_Typ = ARRAY[1..480,1..80] OF BYTE;

VAR   Bildspeicher : Bildspeicher_Typ ABSOLUTE $A000:$0000;
      PCX_File     : FILE;
      Anzahl, Datum, Plane : BYTE;
      Anzahl1,j,z,i,Index,L_Index,S_Index,x,y,c,Zeile : LONGINT;
      L_Puffer     : ARRAY[1..640] OF BYTE;
      Puffer       : ARRAY[1..320] OF BYTE;
      PCX_Kopf     : Kopf;

BEGIN
 ASSIGN(PCX_File,Name);
 RESET(PCX_File,1);
 BLOCKREAD(PCX_File,PCX_Kopf,128);
 IF PCX_Kopf.pal2 = 0 THEN
    BEGIN
     y:=1;
     FOR x:=0 TO 15 DO
         BEGIN
          SETPALETTE(x,x);
          SETRGBPALETTE(x,(PCX_Kopf.pal[y] DIV 4),(PCX_Kopf.pal[y+1] DIV 4),
                       (PCX_Kopf.pal[y+2] DIV 4));
          y:=y+3;
         END;
    END;
 L_Index:=128;
 S_Index:=1;
 FOR Zeile:=1 TO 480 DO
     BEGIN
      Index:=1;
      S_Index:=1;
      SEEK(PCX_File,L_Index);
      IF ((L_Index+640) > FILESIZE(PCX_File)) THEN
                                              Anzahl1:=FILESIZE(PCX_FILE)-L_Index
                                              ELSE
                                              Anzahl1:=640;
      BLOCKREAD(PCX_File,L_Puffer[1],Anzahl1);
      REPEAT
       Datum:=L_Puffer[S_Index];
       INC(S_Index);
       INC(L_Index);
       IF (Datum AND $C0) = $C0 THEN BEGIN
                                 Anzahl:=(Datum AND $3F);
                                 Datum:=L_Puffer[S_Index];
                                 INC(S_Index);
                                 INC(L_Index);
                                 FOR i:=1 TO Anzahl DO
                                     BEGIN
                                      Puffer[Index]:=Datum;
                                      INC(Index);
                                     END;
                                END
                                ELSE BEGIN
                                 Puffer[Index]:=Datum;
                                 INC(Index);
                                END;
      UNTIL Index = 321;
      Index:=1;
      FOR Plane:=0 TO 3 DO
          BEGIN
           Select_Plane(Plane);
           FOR y:=1 TO 80 DO
               BEGIN
                Bildspeicher[Zeile,y]:=Puffer[Index];
                INC(Index);
               END;
          END;
     END;
 CLOSE(PCX_File);
 Select_Plane(4);
END;